#include <STC8H.H>
#include <intrins.h>
#include <absacc.h>
#include <string.h>
#include <stdarg.h>
#include <stdio.h>
#include <math.h>

	#define		TK12	P00		//	0	
	#define		TK13	P01		//	0	
	#define		TK14	P02		//	0	
	#define		TK15	P03		//	0	
	#define		SEG12	P04		//	0	
	#define		SEG9	P05		//	0	
	#define		SEG8	P06		//	0	
	#define		SEG7	P07		//	0	

	#define		RXD2	P10		//	1	˫
	#define		TXD2	P11		//	1	
//	#define		NO		P12		//	0	
	#define		TK3		P13		//	0	
	#define		TK4		P14		//	0	
	#define		TK5		P15		//	0	
	#define		XTALO	P16		//	0	
	#define		XTALI	P17		//	0	

	#define		SEG26	P20		//	0	
	#define		SEG25	P21		//	0	
	#define		SEG24	P22		//	0	
	#define		SEG23	P23		//	0	
	#define		SEG22	P24		//	0	
	#define		SEG21	P25		//	0	
	#define		TK6		P26		//	0	
	#define		TK7		P27		//	0	

	#define		RXD		P30		//	1	˫
	#define		TXD		P31		//	1	
	#define		P32		P32		//	0	
	#define		P33		P33		//	0	
	#define		P34		P34		//	0	
	#define		COM2	P35		//	0	
	#define		COM3	P36		//	0	
	#define		CMP+	P37		//	0	

	#define		P40		P40		//	0	
	#define		SEG30	P41		//	0	
	#define		SEG29	P42		//	0	
	#define		SEG28	P43		//	0	
	#define		SEG27	P44		//	0	
	#define		SEG18	P45		//	0	
	#define		SEG17	P46		//	0	
	#define		SEG4	P47		//	0	

	#define		COM0	P50		//	0	
	#define		COM1	P51		//	0	
	#define		TK10	P52		//	0	
	#define		TK11	P53		//	0	
	#define		TK2		P54		//	0	
//	#define		NO		P55		//	0	
//	#define		NO		P56		//	0	
//	#define		NO		P57		//	0	

	#define		SEG36	P60		//	0	
	#define		SEG37	P61		//	0	
	#define		SEG38	P62		//	0	
	#define		LED_G	P63		//	1	
	#define		DS		P64		//	0	˫
	#define		LED_R	P65		//	1	
	#define		BUZ		P66		//	0	
	#define		LED_B	P67		//	1	

	#define		SEG35	P70		//	0	
	#define		SEG34	P71		//	0	
	#define		SEG33	P72		//	0	
	#define		SEG32	P73		//	0	
	#define		SEG3	P74		//	0	
	#define		SEG2	P75		//	0	
	#define		SEG1	P76		//	0	
	#define		SEG0	P77		//	0	
	
#define		FOSC			24000000UL					//ʱ
#define		BAUD			115200UL					//
#define		TMRF			200UL						//ʱƵ
#define		BRT				(0x10000-(FOSC/BAUD+2)/4)	//ֵ
#define		TMR				(0x10000-FOSC/TMRF/12)		//ʱֵ
#define		T_Buf_Len		64							//Uart1ͻ泤
#define		R_Buf_Len		64							//Uart1ջ泤
#define		LED_ON			0
#define		LED_OFF			1

unsigned char		RP;					//Uart2ָ
unsigned char		TP;					//Uart2ָ
unsigned char		Uart_R_Len;			//Uart2ճ
unsigned char		Uart_T_Len;			//Uart2ͳ
unsigned char xdata	R_Buf[R_Buf_Len];	//Uart2ջ
unsigned char xdata	T_Buf[T_Buf_Len];	//Uart2ͻ

void Delay_ms(unsigned char ms)
{
	unsigned int i;
	do
	{
		i=FOSC/10000;
		while(--i);	//10T per loop
	}
	while(--ms);
}

void UART_Send(unsigned int x)
{
	TP=0;
	Uart_T_Len=x;
	S2CON|=S2TI;
}

void Uart_Printf(unsigned char *v,...)
{
	va_list ap;
	va_start(ap,v);
	while(Uart_T_Len);
	UART_Send(vsprintf(T_Buf,v,ap));
	va_end(ap);
}

void UART_Return(unsigned char temp)
{
	memcpy(T_Buf,R_Buf,temp);
	UART_Send(temp);
}

void Init(void)
{
	P_SW2|=EAXFR;
	
	P0=0x00;
	P1=0x03;
	P2=0x00;
	P3=0x03;
	P4=0x00;
	P5=0x00;
	P6=0xA8;
	P7=0x00;
	
	P0M0=0x00;
	P0M1=0xff; 
	P1M0=0x02;
	P1M1=0xfc; 
	P2M0=0x00;
	P2M1=0xff; 
	P3M0=0x02;
	P3M1=0xfc; 
	P4M0=0x00;
	P4M1=0xff; 
	P5M0=0x00;
	P5M1=0xff; 
	P6M0=0xe8;
	P6M1=0x07; 
	P7M0=0x00;
	P7M1=0xff; 
	
	AUXR=0x04;		//öʱ0ʱΪ12Tģʽöʱ2Ϊ1Tģʽ
	TMOD=0x01;		//öʱ0Ϊ16λԶװģʽ
	TH0=TMR>>8;		//öʱ0ʼֵ
	TL0=TMR;		//öʱ0ʼֵ
	TF0=0;			//TF0жϱ־λ
	ET0=1;			//öʱ0ж
	
	S2CON=0x10;		//UART2ģʽΪ8λݿɱ䲨
	T2H=BRT>>8;		//UART2
	T2L=BRT;		//UART2
	AUXR|=T2R;		//򿪶ʱ2
	IE2|=ES2;		//UART2ж
	
	EA=1;			//ж
	
	LED_R=LED_ON;
	LED_G=LED_ON;
	LED_B=LED_ON;
}

void main(void)
{
	unsigned char i;
	Init();
	while(1)
	{
		Delay_ms(250);
		Delay_ms(250);
		Delay_ms(250);
		Delay_ms(250);
		Uart_Printf("Hello,world! HEX=0x%02bX",i++);
	}
}

void Uart_Start(void)
{
	TH0=TMR>>8;
	TL0=TMR;
	TR0=1;
}

void Uart_Stop(void)
{
	TR0=0;
	TH0=TMR>>8;
	TL0=TMR;
	RP=0;
	memset(R_Buf,0x00,sizeof R_Buf);
}

void Timer0_Isr(void) interrupt TMR0_VECTOR
{
	UART_Return(RP);
	Uart_Stop();
}

void Uart2_Isr(void) interrupt UART2_VECTOR
{
	if(S2CON&S2RI)
	{
		S2CON&=~S2RI;
		Uart_Start();
		R_Buf[RP]=S2BUF;
		if(RP==R_Buf_Len-1)
		{
			Uart_Stop();
		}
		else if(TR0)
		{
			RP++;
		}
	}
	if(S2CON&S2TI)
	{
		S2CON&=~S2TI;
		if(TP==Uart_T_Len)
		{
			TP=0;
			Uart_T_Len=0;
		}
		if(Uart_T_Len!=0)
		{
			S2BUF=(T_Buf[TP]);
			TP++;
		}
	}
}