#include <STC8H.H>
#include <intrins.h>
#include <absacc.h>
#include <string.h>
#include <stdarg.h>
#include <stdio.h>
#include <math.h>

	#define		TK12	P00		//	0	
	#define		TK13	P01		//	0	
	#define		TK14	P02		//	0	
	#define		TK15	P03		//	0	
	#define		SEG12	P04		//	0	
	#define		SEG9	P05		//	0	
	#define		SEG8	P06		//	0	
	#define		SEG7	P07		//	0	

	#define		RXD2	P10		//	1	˫
	#define		TXD2	P11		//	1	
//	#define		NO		P12		//	0	
	#define		TK3		P13		//	0	
	#define		TK4		P14		//	0	
	#define		TK5		P15		//	0	
	#define		XTALO	P16		//	0	
	#define		XTALI	P17		//	0	

	#define		SEG26	P20		//	0	
	#define		SEG25	P21		//	0	
	#define		SEG24	P22		//	0	
	#define		SEG23	P23		//	0	
	#define		SEG22	P24		//	0	
	#define		SEG21	P25		//	0	
	#define		TK6		P26		//	0	
	#define		TK7		P27		//	0	

	#define		RXD		P30		//	1	˫
	#define		TXD		P31		//	1	
	#define		P32		P32		//	0	
	#define		P33		P33		//	0	
	#define		P34		P34		//	0	
	#define		COM2	P35		//	0	
	#define		COM3	P36		//	0	
	#define		CMP+	P37		//	0	

	#define		P40		P40		//	0	
	#define		SEG30	P41		//	0	
	#define		SEG29	P42		//	0	
	#define		SEG28	P43		//	0	
	#define		SEG27	P44		//	0	
	#define		SEG18	P45		//	0	
	#define		SEG17	P46		//	0	
	#define		SEG4	P47		//	0	

	#define		COM0	P50		//	0	
	#define		COM1	P51		//	0	
	#define		TK10	P52		//	0	
	#define		TK11	P53		//	0	
	#define		TK2		P54		//	0	
//	#define		NO		P55		//	0	
//	#define		NO		P56		//	0	
//	#define		NO		P57		//	0	

	#define		SEG36	P60		//	0	
	#define		SEG37	P61		//	0	
	#define		SEG38	P62		//	0	
	#define		LED_G	P63		//	1	
	#define		DS		P64		//	0	˫
	#define		LED_R	P65		//	1	
	#define		BUZ		P66		//	0	
	#define		LED_B	P67		//	1	

	#define		SEG35	P70		//	0	
	#define		SEG34	P71		//	0	
	#define		SEG33	P72		//	0	
	#define		SEG32	P73		//	0	
	#define		SEG3	P74		//	0	
	#define		SEG2	P75		//	0	
	#define		SEG1	P76		//	0	
	#define		SEG0	P77		//	0	
	
#define		FOSC			24000000UL				//ʱ
#define		BAUD			115200UL				//
#define		TMRF			200UL					//ʱƵ
#define		BRT				(0x10000-FOSC/BAUD/4)	//ֵ
#define		TMR				(0x10000-FOSC/TMRF/12)	//ʱֵ
#define		T_Buf_Len		64						//Uart1ͻ泤
#define		R_Buf_Len		64						//Uart1ջ泤
#define		LED_ON			0						//LED
#define		LED_OFF			1						//LED
#define		TS_Channel		12						//ͨ
#define		TS_Compare		0x0800					//Ƚֵ
#define		TS_Range		0x0400					//ֵ

unsigned char		RP;						//Uart2ָ
unsigned char		TP;						//Uart2ָ
unsigned char		Uart_R_Len;				//Uart2ճ
unsigned char		Uart_T_Len;				//Uart2ͳ
unsigned char xdata	R_Buf[R_Buf_Len];		//Uart2ջ
unsigned char xdata	T_Buf[T_Buf_Len];		//Uart2ͻ
unsigned char code	Seg_Map[16]={0x3F,0x06,0x5B,0x4F,0x66,0x6D,0x7D,0x07,0x7F,0x6F,0x77,0x7C,0x39,0x5E,0x79,0x71};	//ܶ루ABCDEFGH
unsigned char		D_Buf[14];				//[0-9]10ֺС(ABCDEFGH)
											//[10](7:3)5-(2:0)(0=OFF 1=SUN 2=MON 6=FRI 7=SAT)
											//[11](7:6)2:(5:4)2-(3)(2)AM(1)PM(0)FM
											//[12](7)V(6)mV(5)V(4)KV(3)(2)H(1)%(0)RH
											//[13](8)STC(1)AC(0)DC
unsigned char code	TS_Map[16]={0xFF,0xFF,0x06,0x05,0x04,0x07,0x08,0x09,0xFF,0xFF,0x02,0x03,0x0A,0x0B,0x00,0x01};	//ͨӳ
unsigned int xdata	TS_Buf[5][TS_Channel];	//ݣʵֵԤֵСֵֵ
unsigned char		TS_Select;				//ѡͨ鿴TS_Buf4λΪάȣΧ0x*0-0x*B4λΪάȣΧ0x0*-0x4*
unsigned char		TS_Scan;				//ɨͨ
bit					TS_Flag;				//жϱ־
unsigned char		TS_Calibrate;			//У׼״̬
unsigned char		TS_Pad;					//ť״̬
unsigned char		TS_Ring;				//״̬
unsigned char		TS_Slide;				//״̬
unsigned int		Ring;					//״̬
unsigned int		Slide;					//״̬


void Delay_ms(unsigned char ms)
{
	unsigned int i;
	do
	{
		i=FOSC/10000;
		while(--i);	//10T per loop
	}
	while(--ms);
}

void UART_Send(unsigned int x)
{
	TP=0;
	Uart_T_Len=x;
	S2CON|=S2TI;
}

//void Uart_Printf(unsigned char *v,...)
//{
//	va_list ap;
//	va_start(ap,v);
//	while(Uart_T_Len);
//	UART_Send(vsprintf(T_Buf,v,ap));
//	va_end(ap);
//}

void UART_Return(unsigned char temp)
{
	memcpy(T_Buf,R_Buf,temp);
	UART_Send(temp);
}

void LCD_Driver(void)
{
	C0SEGV0=((D_Buf[0]&0x08)>>3)|((D_Buf[0]&0x80)>>6)|((D_Buf[1]&0x08)>>1)|((D_Buf[1]&0x80)>>4)|((D_Buf[2]&0x08)<<4)|((D_Buf[10]&0x80)>>3);
	C0SEGV1=((D_Buf[2]&0x80)>>7)|((D_Buf[3]&0x08)>>2)|((D_Buf[3]&0x80)>>3);
	C0SEGV2=((D_Buf[4]&0x08)>>1)|((D_Buf[4]&0x80)>>2)|((D_Buf[10]&0x20)>>4)|((D_Buf[10]&0x08)<<4)|((D_Buf[10]&0x07)==5?0x40:0x00);
	C0SEGV3=((D_Buf[5]&0x08)>>3)|((D_Buf[6]&0x01)<<5)|((D_Buf[11]&0x20)>>2)|((D_Buf[11]&0x08)>>1)|(D_Buf[12]&0x10)|((D_Buf[12]&0x08)<<3);
	C0SEGV4=((D_Buf[6]&0x02)>>1)|((D_Buf[7]&0x01)<<1)|((D_Buf[7]&0x02)<<1)|((D_Buf[8]&0x01)<<3)|((D_Buf[8]&0x02)<<3)|((D_Buf[9]&0x01)<<5)|((D_Buf[9]&0x02)<<5);
	C1SEGV0=((D_Buf[0]&0x10)>>4)|((D_Buf[0]&0x04)>>1)|((D_Buf[1]&0x10)>>2)|((D_Buf[1]&0x04)<<1)|((D_Buf[2]&0x10)<<3)|((D_Buf[11]&0x80)>>3);
	C1SEGV1=((D_Buf[2]&0x04)>>2)|((D_Buf[3]&0x10)>>3)|((D_Buf[3]&0x04)<<2);
	C1SEGV2=((D_Buf[4]&0x10)>>2)|((D_Buf[4]&0x04)<<3)|((D_Buf[10]&0x07)==4?0x40:0x00)|((D_Buf[10]&0x07)==6?0x80:0x00)|((D_Buf[11]&0x40)>>5);
	C1SEGV3=((D_Buf[5]&0x10)>>4)|((D_Buf[5]&0x04)>>1)|(D_Buf[6]&0x20)|((D_Buf[11]&0x01)<<2)|((D_Buf[12]&0x20)>>1)|((D_Buf[12]&0x04)<<4)|((D_Buf[13]&0x01)<<3);
	C1SEGV4=((D_Buf[6]&0x40)>>6)|((D_Buf[7]&0x20)>>4)|((D_Buf[7]&0x40)>>4)|((D_Buf[8]&0x20)>>2)|((D_Buf[8]&0x40)>>2)|(D_Buf[9]&0x20)|(D_Buf[9]&0x40);
	C2SEGV0=((D_Buf[0]&0x20)>>5)|((D_Buf[0]&0x40)>>5)|((D_Buf[1]&0x20)>>3)|((D_Buf[1]&0x40)>>3)|((D_Buf[2]&0x20)<<2)|((D_Buf[10]&0x40)>>2);
	C2SEGV1=((D_Buf[2]&0x40)>>6)|((D_Buf[3]&0x20)>>4)|((D_Buf[3]&0x40)>>2);
	C2SEGV2=((D_Buf[4]&0x20)>>3)|((D_Buf[4]&0x40)>>1)|((D_Buf[10]&0x10)>>3)|((D_Buf[10]&0x07)==3?0x40:0x00)|((D_Buf[10]&0x07)==7?0x80:0x00);
	C2SEGV3=((D_Buf[5]&0x20)>>5)|((D_Buf[5]&0x40)>>5)|((D_Buf[6]&0x10)<<1)|(D_Buf[11]&0x04)|((D_Buf[12]&0x40)>>2)|((D_Buf[12]&0x01)<<6)|((D_Buf[13]&0x02)<<2);
	C2SEGV4=((D_Buf[6]&0x04)>>2)|((D_Buf[7]&0x10)>>3)|(D_Buf[7]&0x04)|((D_Buf[8]&0x10)>>1)|((D_Buf[8]&0x04)<<2)|((D_Buf[9]&0x10)<<1)|((D_Buf[9]&0x04)<<4);
	C3SEGV0=(D_Buf[0]&0x01)|(D_Buf[0]&0x02)|((D_Buf[1]&0x01)<<2)|((D_Buf[1]&0x02)<<2)|((D_Buf[2]&0x01)<<7);
	C3SEGV1=((D_Buf[2]&0x02)>>1)|((D_Buf[3]&0x01)<<1)|((D_Buf[3]&0x02)<<3);
	C3SEGV2=((D_Buf[4]&0x01)<<2)|((D_Buf[4]&0x02)<<4)|((D_Buf[10]&0x07)==1?0x80:0x00)|((D_Buf[10]&0x07)==2?0x40:0x00)|((D_Buf[13]&0x80)>>6);
	C3SEGV3=(D_Buf[5]&0x01)|(D_Buf[5]&0x02)|((D_Buf[6]&0x08)<<2)|((D_Buf[11]&0x10)>>1)|((D_Buf[11]&0x02)<<1)|((D_Buf[12]&0x80)>>3)|((D_Buf[12]&0x02)<<5);
	C3SEGV4=((D_Buf[6]&0x80)>>7)|((D_Buf[7]&0x08)>>2)|((D_Buf[7]&0x80)>>5)|(D_Buf[8]&0x08)|((D_Buf[8]&0x80)>>3)|((D_Buf[9]&0x08)<<2);
}

void LCD_Display(unsigned long a,unsigned int b)
{
	D_Buf[0]=Seg_Map[a%1000000/100000];
	D_Buf[1]=Seg_Map[a%100000/10000];
	D_Buf[2]=Seg_Map[a%10000/1000];
	D_Buf[3]=Seg_Map[a%1000/100];
	D_Buf[4]=Seg_Map[a%100/10];
	D_Buf[5]=Seg_Map[a%10];
	D_Buf[6]=Seg_Map[(b>>8)&0x0F];
	D_Buf[7]=0x00;
	D_Buf[8]=Seg_Map[(b>>4)&0x0F];
	D_Buf[9]=Seg_Map[b&0x0F];
//	D_Buf[10]=0x00;	//[10](7:3)5-(2:0)(0=OFF 1=SUN 2=MON 6=FRI 7=SAT)
//	D_Buf[11]=0x00;	//[11](7:6)2:(5:4)2-(3)(2)AM(1)PM(0)FM
//	D_Buf[12]=0x00;	//[12](7)V(6)mV(5)V(4)KV(3)(2)H(1)%(0)RH
//	D_Buf[13]=0x00;	//[13](8)STC(1)AC(0)DC
	D_Buf[10]=TS_Pad;
	D_Buf[10]=((D_Buf[10]&0xAA)>>1)|((D_Buf[10]&0x55)<<1);
	D_Buf[10]=((D_Buf[10]&0xCC)>>2)|((D_Buf[10]&0x33)<<2);
	D_Buf[10]=((D_Buf[10]>>4)|(D_Buf[10]<<4));
	D_Buf[11]=TS_Ring&0x07;
	D_Buf[11]=((D_Buf[11]&0xAA)>>1)|((D_Buf[11]&0x55)<<1);
	D_Buf[11]=((D_Buf[11]&0xCC)>>2)|((D_Buf[11]&0x33)<<2);
	D_Buf[11]=((D_Buf[11]>>4)|(D_Buf[11]<<4));
	D_Buf[11]>>=5;
	D_Buf[11]|=(TS_Ring&0x80)>>1;
	D_Buf[12]=TS_Slide&0x0F;
	D_Buf[12]=((D_Buf[12]&0xAA)>>1)|((D_Buf[12]&0x55)<<1);
	D_Buf[12]=((D_Buf[12]&0xCC)>>2)|((D_Buf[12]&0x33)<<2);
	D_Buf[12]=((D_Buf[12]>>4)|(D_Buf[12]<<4));
	D_Buf[11]|=TS_Slide&0x80;
	LCD_Driver();
}

unsigned int Compare(bit x,unsigned int a,unsigned int b)
{
	return a==b?a:(x==0?(a<b?a:b):(a>b?a:b));
}

void Calibrate(void)
{
	unsigned char i;
	static unsigned char flag;
	switch(TS_Calibrate)
	{
		case 0:
			flag=0x0F;
		break;
		case 1:
			if(flag&0x01)
			{
				flag&=0x0E;
				TS_Buf[2][TS_Select&0x0F]=TS_Buf[1][TS_Select&0x0F];
			}
			else
			{
				TS_Buf[2][TS_Select&0x0F]=Compare(0,TS_Buf[1][TS_Select&0x0F],TS_Buf[2][TS_Select&0x0F]);
			}
		break;
		case 2:
			if(flag&0x02)
			{
				flag&=0x0D;
				TS_Buf[3][TS_Select&0x0F]=TS_Buf[1][TS_Select&0x0F];
			}
			else
			{
				TS_Buf[3][TS_Select&0x0F]=Compare(1,TS_Buf[1][TS_Select&0x0F],TS_Buf[3][TS_Select&0x0F]);
			}
		break;
		case 3:
			if(flag&0x04)
			{
				flag&=0x0B;
				for(i=0;i<TS_Channel;i++)
				{
					TS_Buf[2][i]=TS_Buf[1][i];
				}
			}
			else
			{
				for(i=0;i<TS_Channel;i++)
				{
					TS_Buf[2][i]=Compare(0,TS_Buf[1][i],TS_Buf[2][i]);
				}
			}
		break;
		case 4:
			if(flag&0x08)
			{
				flag&=0x07;
				for(i=0;i<TS_Channel;i++)
				{
					TS_Buf[3][i]=TS_Buf[1][i];
				}
			}
			else
			{
				for(i=0;i<TS_Channel;i++)
				{
					TS_Buf[3][i]=Compare(1,TS_Buf[1][i],TS_Buf[3][i]);
				}
			}
		break;
		default:
			
		break;
	}
}

void Touch_Pad(void)
{
	unsigned char i;
	unsigned int limit_l,limit_h;
	limit_l=TS_Compare-TS_Range/2;
	limit_h=TS_Compare+TS_Range/2;
	for(i=0;i<5;i++)
	{
		if(TS_Buf[4][i]<=limit_l)
		{
			TS_Pad&=~(0x01<<i);
		}
		if(TS_Buf[4][i]>=limit_h)
		{
			TS_Pad|=0x01<<i;
		}
	}
}

void Touch_Ring(void)
{
	unsigned char i;
	unsigned int limit_l,limit_h;
	limit_l=TS_Compare-TS_Range/2;
	limit_h=TS_Compare+TS_Range/2;
	for(i=0;i<3;i++)
	{
		if(TS_Buf[4][i+5]<=limit_l)
		{
			TS_Ring&=~(0x01<<i);
		}
		if(TS_Buf[4][i+5]>=limit_h)
		{
			TS_Ring|=0x01<<i;
		}
	}
	if(TS_Ring&0x07)
	{
		TS_Ring|=0x80;
	}
	else
	{
		TS_Ring&=0x7F;
	}
}

void Touch_Slide(void)
{
	unsigned char i;
	unsigned int limit_l,limit_h;
	limit_l=TS_Compare-TS_Range/2;
	limit_h=TS_Compare+TS_Range/2;
	for(i=0;i<4;i++)
	{
		if(TS_Buf[4][i+8]<=limit_l)
		{
			TS_Slide&=~(0x01<<i);
		}
		if(TS_Buf[4][i+8]>=limit_h)
		{
			TS_Slide|=0x01<<i;
		}
	}
	if(TS_Slide&0x0F)
	{
		TS_Slide|=0x80;
	}
	else
	{
		TS_Slide&=0x7F;
	}
}

void Touch_Key(void)
{
	unsigned char i;
	if(TS_Flag)
	{
		TS_Flag=0;
		for(i=0;i<TS_Channel;i++)
		{
			TS_Buf[1][i]=TS_Buf[1][i]*3+((0xFFFF-TS_Buf[0][i])>>2)>>2;
			if(TS_Buf[3][i]>TS_Buf[2][i])
			{
				TS_Buf[4][i]=(TS_Buf[1][i]>TS_Buf[2][i]?(TS_Buf[1][i]-TS_Buf[2][i]):0)*0x1000UL/(TS_Buf[3][i]-TS_Buf[2][i]);
				if(TS_Buf[4][i]>0x0FFF)
				{
					TS_Buf[4][i]=0x0FFF;
				}
			}
			else
			{
				TS_Buf[4][i]=0;
			}
		}
		Calibrate();
		Touch_Pad();
		Touch_Ring();
		Touch_Slide();
	}
}

void Init(void)
{
	P_SW2|=EAXFR;
	
	P0=0x00;
	P1=0x03;
	P2=0x00;
	P3=0x03;
	P4=0x00;
	P5=0x00;
	P6=0xA8;
	P7=0x00;
	
	P0M0=0x00;
	P0M1=0xFF; 
	P1M0=0x02;
	P1M1=0xFC; 
	P2M0=0x00;
	P2M1=0xFF; 
	P3M0=0x02;
	P3M1=0xFC; 
	P4M0=0x00;
	P4M1=0xFF; 
	P5M0=0x00;
	P5M1=0xFF; 
	P6M0=0xE8;
	P6M1=0x07; 
	P7M0=0x00;
	P7M1=0xFF; 
	
	X32KCR=0xC0;	//ⲿ32768ø
	while(!(X32KCR&0x01));
	
	AUXR=0x04;		//öʱ0ʱΪ12Tģʽöʱ2Ϊ1Tģʽ
	TMOD=0x01;		//öʱ0Ϊ16λԶװģʽ
	TH0=TMR>>8;		//öʱ0ʼֵ
	TL0=TMR;		//öʱ0ʼֵ
	TF0=0;			//TF0жϱ־λ
	ET0=1;			//öʱ0ж
	
	S2CON=0x10;		//UART2ģʽΪ8λݿɱ䲨
	T2H=BRT>>8;		//UART2
	T2L=BRT;		//UART2
	AUXR|=T2R;		//򿪶ʱ2
	IE2|=ES2;		//UART2ж
	
	LCDCFG2=0x0F;	//SEGλ
	LCDCFG=0x80;	//LCDʱΪⲿ32768HzVLCDΪ0.65*VCC3.25V
	DBLEN=0x00;		//ʱ
	COMLENL=0x3F;	//COMʱ
	COMLENM=0x00;	//COMʱ
	COMLENH=0x00;	//COMʱ
	BLINKRATE=0x40;	//˸
	COMON=0x0F;		//COMʹ
	SEGON1=0x9F;	//SEGʹ
	SEGON2=0x13;	//SEGʹ
	SEGON3=0xE6;	//SEGʹ
	SEGON4=0x7F;	//SEGʹ
	SEGON5=0x7F;	//SEGʹ
	LCDCR=0x01;		//LCDͨʾģʽ
	
	TSCHEN1=0xFC;	//TK00~TK07
	TSCHEN2=0xFC;	//TK08~TK15
	TSRT=0x00;		//ûLEDʱɨ
	TSCFG1=0x73;	//صݹƵ = fosc/(2*(TSCFG1[6:4]+1))ŵʱ(ϵͳʱ) 0(125) 1(250) 2(500) 3(1000) 4(2000) 5(2500) 6(5000) 7(7500) С3
	TSCFG2=0x03;	//ôڲοѹ(AVCCķѹ)0(1/4)  1(1/2)  2(5/8)  3(3/4)
	TSCTRL=0x33;	//ظɨģʽһɨͣ͹ģʽʱΪⲿ32768񣬹رֱȽرյ͹Ļѣ4ƽB7: TSGOB6: SINGLEB5: TSWAITB4: TSWUCSB3: TSDCENB2: TSWUENB1 B0: TSSAMP
	TSCTRL|=0x80;	//ʼɨ
	IE2|=0x80;		//ôж
	
	EA=1;			//ж
		
	LED_R=LED_ON;
	LED_G=LED_ON;
	LED_B=LED_ON;
	
	C0SEGV0=0x00;
	C0SEGV1=0x00;
	C0SEGV2=0x00;
	C0SEGV3=0x00;
	C0SEGV4=0x00;
	C1SEGV0=0x00;
	C1SEGV1=0x00;
	C1SEGV2=0x00;
	C1SEGV3=0x00;
	C1SEGV4=0x00;
	C2SEGV0=0x00;
	C2SEGV1=0x00;
	C2SEGV2=0x00;
	C2SEGV3=0x00;
	C2SEGV4=0x00;
	C3SEGV0=0x00;
	C3SEGV1=0x00;
	C3SEGV2=0x00;
	C3SEGV3=0x00;
	C3SEGV4=0x00;
	
	memset(R_Buf,0x00,sizeof R_Buf);
	memset(T_Buf,0x00,sizeof T_Buf);
	memset(TS_Buf,0x00,sizeof TS_Buf);
	
	TS_Buf[2][0x00]=11800;
	TS_Buf[2][0x01]=11560;
	TS_Buf[2][0x02]=11010;
	TS_Buf[2][0x03]=10840;
	TS_Buf[2][0x04]=10730;
	TS_Buf[2][0x05]=13960;
	TS_Buf[2][0x06]=14060;
	TS_Buf[2][0x07]=14010;
	TS_Buf[2][0x08]=10660;
	TS_Buf[2][0x09]=10940;
	TS_Buf[2][0x0A]=11160;
	TS_Buf[2][0x0B]=10980;
	TS_Buf[3][0x00]=14820;
	TS_Buf[3][0x01]=14850;
	TS_Buf[3][0x02]=14740;
	TS_Buf[3][0x03]=14530;
	TS_Buf[3][0x04]=14690;
	TS_Buf[3][0x05]=15010;
	TS_Buf[3][0x06]=15040;
	TS_Buf[3][0x07]=15100;
	TS_Buf[3][0x08]=14630;
	TS_Buf[3][0x09]=14220;
	TS_Buf[3][0x0A]=14390;
	TS_Buf[3][0x0B]=14610;
	
	TS_Select=0x44;
}

void main(void)
{
	Init();
	while(1)
	{
		Touch_Key();
		LCD_Display(TS_Buf[TS_Select>>4][TS_Select&0x0F],(TS_Calibrate<<8)|TS_Select);
		Delay_ms(20);
	}
}

void Uart_Start(void)
{
	TH0=TMR>>8;
	TL0=TMR;
	TR0=1;
}

void Uart_Stop(void)
{
	TR0=0;
	TH0=TMR>>8;
	TL0=TMR;
	RP=0;
	memset(R_Buf,0x00,sizeof R_Buf);
}

void Timer0_Isr(void) interrupt TMR0_VECTOR
{
	if(((R_Buf[0]>>4)<=4)&&((R_Buf[0]&0x0F)<=0x0B))
		TS_Select=R_Buf[0];
	else if(((R_Buf[0]>>4)==0x05)&&((R_Buf[0]&0x0F)<=0x04))
		TS_Calibrate=R_Buf[0]&0x07;
	UART_Return(RP);
	Uart_Stop();
}

void Uart2_Isr(void) interrupt UART2_VECTOR
{
	if(S2CON&S2RI)
	{
		S2CON&=~S2RI;
		Uart_Start();
		R_Buf[RP]=S2BUF;
		if(RP==R_Buf_Len-1)
		{
			Uart_Stop();
		}
		else if(TR0)
		{
			RP++;
		}
	}
	if(S2CON&S2TI)
	{
		S2CON&=~S2TI;
		if(TP==Uart_T_Len)
		{
			TP=0;
			Uart_T_Len=0;
		}
		if(Uart_T_Len!=0)
		{
			S2BUF=(T_Buf[TP]);
			TP++;
		}
	}
}

void TKSU_Isr(void) interrupt TKSU_VECTOR
{
	unsigned char temp;
	temp=TSSTA2;
	if(temp&0x40)		//, 
	{
		TSSTA2|=0x40;	//д1
	}
	else if(temp&0x80)	//ɨ
	{
		TS_Scan=temp&0x0f;
		if(TS_Map[TS_Scan]!=0xFF)	//ͨȷ
		{
			TS_Buf[0][TS_Map[TS_Scan]]=TSDAT;	//ĳͨĶ
			TS_Flag=1;
		}
	}
	TSSTA2|=0x80;		//д1
}